﻿
using Syncfusion.XForms.ComboBox;
using Syncfusion.XForms.DataForm;
using Syncfusion.XForms.DataForm.Editors;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace DataFormDropDown
{
    public class DataFormBehavior : Behavior<ContentPage>
    {
        SfDataForm dataForm = null;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            dataForm = bindable.FindByName<SfDataForm>("dataForm");
            dataForm.SourceProvider = new SourceProviderExt();
            dataForm.DataObject = new ContactInfo();
            dataForm.AutoGeneratingDataFormItem += DataForm_AutoGeneratingDataFormItem;
            dataForm.RegisterEditor("City", "DropDown");
        }
        private void DataForm_AutoGeneratingDataFormItem(object sender, AutoGeneratingDataFormItemEventArgs e)
        {
            if (e.DataFormItem != null && e.DataFormItem.Name == "City")
            {
                (e.DataFormItem as DataFormDropDownItem).DisplayMemberPath = "City";
                (e.DataFormItem as DataFormDropDownItem).SelectedValuePath = "PostalCode";
            }
        }
    }

    public class SourceProviderExt : SourceProvider
    {
        public override IList GetSource(string sourceName)
        {
            if (sourceName == "City")
            {
                List<Address> details = new List<Address>();
                details.Add(new Address() { City = "Chennai", PostalCode = 1 });
                details.Add(new Address() { City = "Paris", PostalCode = 2 });
                details.Add(new Address() { City = "Vatican", PostalCode = 3 });

                return details;
            }
            return new List<string>();
        }
    }

    public class ContactInfo
    {
        public String FirstName { get; set; }
        public string City { get; set; }
    }

    public class Address
    {
        public int PostalCode { get; set; }
        public string City { get; set; }
    }
}
